<?php
/* Photopress shared include file */

load_plugin_textdomain('photopress');

$pp_options = array();

if (get_option('pp_options')) {
	$pp_options = get_option('pp_options');
}

if (empty($pp_options['photospath'])) {
	$pp_options['photospath'] = ABSPATH . 'wp-content/photos';
}

if (empty($pp_options['wpaddress'])) {
	$pp_options['wpaddress'] = get_settings('siteurl');
}

if (empty($pp_options['photosaddress'])) {
	$pp_options['photosaddress'] = $pp_options['wpaddress'] . '/wp-content/photos';
}

if ($pp_options['use_permalinks'] != '0' && $pp_options['use_permalinks'] != '1') {
	$pp_options['use_permalinks'] = '0';
}

if (empty($pp_options['album_token'])) {
	$pp_options['album_token'] = 'album';
}

if (empty($pp_options['cat_token'])) {
	$pp_options['cat_token'] = 'cat';
}

if (empty($pp_options['images_token'])) {
	$pp_options['images_token'] = 'images';
}

if ($pp_options['originals'] != '0' && $pp_options['originals'] != '1') {
	$pp_options['originals'] = '0';
}

if (empty($pp_options['origprefix'])) {
	$pp_options['origprefix'] = 'orig_';
}

if (empty($pp_options['min_level'])) {
	$pp_options['min_level'] = '2';
}

if (empty($pp_options['maxk'])) {
	$pp_options['maxk'] = '512';
}

if (empty($pp_options['maxsize'])) {
	$pp_options['maxsize'] = '450';
}

if (empty($pp_options['thumbsize'])) {
	$pp_options['thumbsize'] = '130';
}

if (empty($pp_options['quality'])) {
	$pp_options['quality'] = '80';
}

if (empty($pp_options['allowedtypes'])) {
	$pp_options['allowedtypes'] = 'jpg jpeg gif png';
}

if ($pp_options['allow_post_image_delete'] != '0' && $pp_options['allow_post_image_delete'] != '1') {
	$pp_options['allow_post_image_delete'] = '0';
}

if ($pp_options['thumbs_in_mass_edit'] != '0' && $pp_options['thumbs_in_mass_edit'] != '1') {
	$pp_options['thumbs_in_mass_edit'] = '1';
}

if ($pp_options['show_posts'] != '0' && $pp_options['show_posts'] != '1') {
	$pp_options['show_posts'] = '0';
}

if ($pp_options['failsafe_buttons'] != '0' && $pp_options['failsafe_buttons'] != '1') {
	$pp_options['failsafe_buttons'] = '0';
}

if ($pp_options['insert_thumb'] != '0' && $pp_options['insert_thumb'] != '1') {
	$pp_options['insert_thumb'] = '1';
}

if ($pp_options['album'] != '0' && $pp_options['album'] != '1') {
	$pp_options['album'] = '1';
}

if ($pp_options['meta_link'] != '0' && $pp_options['meta_link'] != '1') {
	$pp_options['meta_link'] = '1';
}

if ($pp_options['meta_rand'] != '0' && $pp_options['meta_rand'] != '1') {
	$pp_options['meta_rand'] = '1';
}

if (empty($pp_options['images_per_page'])) {
	$pp_options['images_per_page'] = '30';
}

if (empty($pp_options['album_columns'])) {
	$pp_options['album_columns'] = '2';
}

if (empty($pp_options['manager_columns'])) {
	$pp_options['manager_columns'] = '4';
}

if (empty($pp_options['thumbprefix'])) {
	$pp_options['thumbprefix'] = 'thumb_';
}

if (empty($pp_options['image_class'])) {
	$pp_options['image_class'] = 'centered alignleft alignright';
}

if (empty($pp_options['rand_class'])) {
	$pp_options['rand_class'] = 'centered';
}

if ($pp_options['use_permalinks'] == '1' && isset($wp_rewrite) && $wp_rewrite->using_permalinks()) {
	$pp_options['albumaddress'] = trailingslashit($pp_options['wpaddress']) . $pp_options['album_token'];
	$pp_options['cataddress'] = trailingslashit(trailingslashit($pp_options['albumaddress']) . $pp_options['cat_token']);
	$pp_options['imgaddress'] = trailingslashit(trailingslashit($pp_options['albumaddress']) . $pp_options['images_token']);
	$pp_options['page_token'] = '/';
} else {
	$pp_options['albumaddress'] = trailingslashit($pp_options['wpaddress']) . '?pp_album=main';
	$pp_options['cataddress'] = $pp_options['albumaddress'] . '&pp_cat=';
	$pp_options['imgaddress'] = $pp_options['albumaddress'] . '&pp_image=';
	$pp_options['page_token'] = '&pp_page=';
}

// cleans up data for insert into db
function pp_cleanstring($string) {
	$string = (get_magic_quotes_gpc() == 1) ? stripslashes($string) : $string;
	if (is_numeric($string)) {
		return (int)$string;
	} else {
		return mysql_real_escape_string($string);
	}
}

// Shared update function so the uploader can save data to the table. Receives an array which should include filename, short image name, image description, and image category. If the file doesn't exist it returns FALSE.
function pp_table_update($pp_update_array) {
	global $table_prefix, $wpdb, $pp_options;
	$table_name = $table_prefix . "photopress";
	if (is_file($pp_options['photospath'] . '/' . $pp_update_array[0])) {
		$imgfile = $wpdb->escape($pp_update_array[0]);
		$imgname = $wpdb->escape($pp_update_array[1]);
		$imgdesc = $wpdb->escape($pp_update_array[2]);
		$imgcat = $wpdb->escape($pp_update_array[3]);
		$imgtime = filemtime($pp_options['photospath'] . '/' . $pp_update_array[0]);
		// if the image is already in there we'll update the row with the new data
		if ($wpdb->get_var("SELECT imgfile FROM $table_name WHERE binary imgfile='$imgfile'")) {
			return $wpdb->query("UPDATE $table_name SET imgname='$imgname', imgdesc='$imgdesc', imgcat='$imgcat', imgtime='$imgtime' WHERE imgfile='$imgfile'");
		// if the image isn't in there we'll add a new row
		} else {
			return $wpdb->query("INSERT INTO $table_name SET imgfile='$imgfile', imgname='$imgname',imgdesc='$imgdesc',imgcat='$imgcat',imgtime='$imgtime'");
		}
	} else {
		return FALSE;
	}
}

// gets data for a photo from the database, or makes up some data based on the filename
function pp_get_data($image) {
	global $table_prefix, $wpdb, $pp_options;
	$table_name = $table_prefix . 'photopress';
	if ($results = $wpdb->get_row("SELECT * FROM $table_name WHERE imgfile = '$image'", ARRAY_A)) {
		return $results;
	} else {
		return FALSE;
	}
}

// gives a count of images in $category, or full count otherwise
function pp_count($category=FALSE) {
	global $table_prefix, $wpdb;
	$table_name = $table_prefix . 'photopress';
	if (empty($category)) {
		if ($results = $wpdb->get_var("SELECT count(*) FROM $table_name")) {
			return $results;
		} else {
			return FALSE;
		}
	} else {
		$cat_for_query = $wpdb->escape($category);
		if ($results = $wpdb->get_var("SELECT count(*) FROM $table_name WHERE binary imgcat='$cat_for_query'")) {
			return $results;
		} else {
			return FALSE;
		}
	}
}

// function to get an array of categories from the db
function pp_list_cats() {
	global $table_prefix, $wpdb;
	$table_name = $table_prefix . "photopress";
	if ($results = $wpdb->get_col("SELECT imgcat FROM $table_name")) {
		foreach ($results as $cats) {
			$cats = stripslashes($cats);
		}
		if (is_array($results)) {
			sort($results);
		}
		return array_unique($results);
	} else {
		return FALSE;
	}
}

// gets an array of $rows image arrays in $category (if given, from whole table otherwise), sorted by $sort, starting with $offset
function pp_images_with_data($category=FALSE,$sort='imgname',$offset=0,$rows=50) {
	global $table_prefix, $wpdb;
	$table_name = $table_prefix . "photopress";
	if (!empty($category)) {
		$cat_for_query = $wpdb->escape($category);
		if ($results = $wpdb->get_results("SELECT * FROM $table_name WHERE binary imgcat='$cat_for_query' ORDER BY $sort LIMIT $offset,$rows",ARRAY_A)) {
			return $results;
		} else {
			return FALSE;
		}
	} else {
		if ($results = $wpdb->get_results("SELECT * FROM $table_name ORDER BY $sort LIMIT $offset,$rows", ARRAY_A)) {
			return $results;
		} else {
			return FALSE;
		}
	}
}

// function to get an array of the images in a category
function pp_cat_images($category) {
	global $table_prefix, $wpdb;
	$cat_for_query = $wpdb->escape($category);
	$images_in_folder = array();
	$images_in_cat = array();
	$images_in_db = array();
	$results = array();
	if (pp_folder_contents()) {
		$images_in_folder = pp_folder_contents();
		$table_name = $table_prefix . "photopress";
		if ($wpdb->get_var("show tables like '$table_name'") == $table_name) {
			$images_in_cat = $wpdb->get_col("SELECT imgfile FROM $table_name WHERE binary imgcat='$cat_for_query'");
			$images_in_db = $wpdb->get_col("SELECT imgfile FROM $table_name");
		}
	// add orphan images to the Default category
		if ($category == 'Default') {
			$results = array_diff($images_in_folder,$images_in_db);
			$results = array_merge((array)$results,(array)$images_in_cat);
			if (is_array($results)) {
				sort($results);
			}
		} else {
			$results = $images_in_cat;
			if (is_array($results)) {
				sort($results);
			}
		}
		if (empty($results)) {
			return FALSE;
		} else {
			return $results;
		}
	} else {
		return FALSE;
	}
}

// Returns an array of image names within photospath with matching thumbs (ignores images without thumbs). Doesn't check whether the images have data in the db.
function pp_folder_contents() {
	global $pp_options;
	$allowedtypes = trim(strtolower($pp_options['allowedtypes']));
	$allowedtypes = preg_replace("/ /","|",$allowedtypes);
	$fileglob = '@\.(' . $allowedtypes . ')$@i';
	$handle = opendir($pp_options['photospath']);
	$list_array = array();
	while (false !== ($folder_contents = readdir($handle))) {
		$image_name = substr($folder_contents, strlen($pp_options['thumbprefix']));
		if ((preg_match($fileglob, $folder_contents)) && (strstr($folder_contents, $pp_options['thumbprefix'])) && is_file($pp_options['photospath'] . '/' . $image_name)) { // make sure both thumb and regular image are there
			$list_array[] = $image_name;
		}
	}
	if (count($list_array) > 1) {
		sort($list_array);
	}
	if (count($list_array) > 0) {
		return $list_array;
	} else {
		return FALSE;
	}
}

// make a list of html option tags for a category select list (the part between the select tags), adding Default and setting it as selected if no selected cat is provided (or if the one provided has no images)
function pp_cat_dropdown($pp_cats,$selected='Default') {
	$pp_cats[] = 'Default';
	$pp_cats = array_unique($pp_cats);
	$code = '';
	foreach ($pp_cats as $category) {
		$code .= '<option value="' . stripslashes($category) . '"';
		if ($selected == stripslashes($category)) { $code .= ' selected="selected"'; }
		$code .= '>' . stripslashes($category) . '</option>';
	}
	return $code;
}

// resizing function: blatently stolen from the built-in wordpress uploader. makes thumbs and resized images 
function pp_resize($file, $maxsize, $minsize, $prefix = '') {
    global $pp_options;

    // 1 = GIF, 2 = JPEG, 3 = PNG

    if(file_exists($file)) {
        $type = getimagesize($file);
        
        // if the associated function doesn't exist - then it's not
        // handle. duh. i hope.
        
        if(!function_exists('imagegif') && $type[2] == 1) {
            $error = __('Filetype not supported. Image not resized.','photopress');
        }elseif(!function_exists('imagejpeg') && $type[2] == 2) {
            $error = __('Filetype not supported. Image not resized.','photopress');
        }elseif(!function_exists('imagepng') && $type[2] == 3) {
            $error = __('Filetype not supported. Image not resized.','photopress');
        } else {
        
            // create the initial copy from the original file
            if($type[2] == 1) {
                $image = imagecreatefromgif($file);
            } elseif($type[2] == 2) {
                $image = imagecreatefromjpeg($file);
            } elseif($type[2] == 3) {
                $image = imagecreatefrompng($file);
            }
            
			if (function_exists('imageantialias'))
	            imageantialias($image, TRUE);
            
            $image_attr = getimagesize($file);

            // anti-upsize fix contributed by Jono (jono@redcliffs.net)
	    // set the current image width and heights
            $image_width = $image_attr[0];
            $image_height = $image_attr[1];

            // if image is larger than defined max size
            if($image_width >= $maxsize || $image_height >= $maxsize || $image_width <= $minsize || $image_height <= $minsize) {
               // figure out the longest side            
               if($image_width > $image_height) {
                  $image_new_width = $maxsize;
                  $image_ratio = $image_width/$image_new_width;
                  $image_new_height = $image_height/$image_ratio;
                  //width is > height
               } else {
                  $image_new_height = $maxsize;
                  $image_ratio = $image_height/$image_new_height;
                  $image_new_width = $image_width/$image_ratio;
                  //height > width
               }
            
            $resized = imagecreatetruecolor($image_new_width, $image_new_height);
            @imagecopyresampled($resized, $image, 0, 0, 0, 0, $image_new_width, $image_new_height, $image_attr[0], $image_attr[1]);
            
            // move the thumbnail to it's final destination
            
            $path = explode('/', $file);
            $resizedpath = substr($file, 0, strrpos($file, '/')) . '/' . $prefix . $path[count($path)-1];
            
            if($type[2] == 1) {
                if(!imagegif($resized, $resizedpath)) {
                    $error = __('Photo path invalid','photopress');
                }
            } elseif($type[2] == 2) {
                if(!imagejpeg($resized, $resizedpath, $pp_options['quality'])) {
                    $error = __('Photo path invalid','photopress');
                }
            } elseif($type[2] == 3) {
                if(!imagepng($resized, $resizedpath)) {
                    $error = __('Photo path invalid','photopress');
                }
            }
          } else { $error = __('Image not resized, is smaller than ' . $maxsize . 'x' . $maxsize);
	  }
        }
    }
    
    if(!empty($error))
    {
        return $error;
    }
    else
    {
        return 1;
    }
}

?>
